/*
 * Created on May 7, 2005
 *
 *Copyright (c) 2005 The Regents of the University of Salzburg.
 *All rights reserved.
 *Permission is hereby granted, without written agreement and without
 *license or royalty fees, to use, copy, modify, and distribute this
 *software and its documentation for any purpose, provided that the above
 *copyright notice and the following two paragraphs appear in all copies
 *of this software.
 *
 *IN NO EVENT SHALL THE UNIVERSITY OF SALZBURG BE LIABLE TO ANY PARTY
 *FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 *ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
 *THE UNIVERSITY OF SALZBURG HAS BEEN ADVISED OF THE POSSIBILITY OF
 *SUCH DAMAGE.

 *THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 *INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 *MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
 *PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
 *SALZBURG HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
 *ENHANCEMENTS, OR MODIFICATIONS.
 */
package flathtlc;

import flathtlc.node.AModeDeclaration;
import flathtlc.node.AModuleDeclaration;
import flathtlc.node.AProgramDeclaration;
import flathtlc.node.ATaskDeclaration;
import flathtlc.node.TIdent;

/**
 * @author Daniel Iercan daniel.iercan@cs.uni-salzburg.at
 *
 */
public class Utils {

	/**
	 * Get the module where the specified mode is being defined
	 * @param node
	 * @return
	 */
	public AModuleDeclaration getModule(AModeDeclaration node){
		return (AModuleDeclaration)node.parent().parent();
	}
	
	/**
	 * Get the program where the specified mode is being defined
	 * @param node
	 * @return
	 */
	public AProgramDeclaration getProgram(AModeDeclaration node){
		return (AProgramDeclaration)getModule(node).parent().parent();
	}
	
	/**
	 * Get the program where the specified module is being defined
	 * @param node
	 * @return
	 */
	public AProgramDeclaration getProgram(AModuleDeclaration node){
		return (AProgramDeclaration)node.parent().parent();
	}
    
    public static String getIdentCoord(TIdent ident){
        return "["+ident.getLine()+", "+ident.getPos()+"]";
    }
    
    public static String TIdent2String(TIdent ident){
        return ident.getText()+getIdentCoord(ident);
    }
    
    public static boolean isAbstract(ATaskDeclaration node){
    	return node.getTaskFunction()==null;
    }
}
